package thunder.jbossmt.ejb;

import java.util.Hashtable;
import javax.ejb.Stateless;
import javax.ejb.EJB;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

@Stateless(name = "FacadeBeanName", mappedName = "FacadeBeanMappedName")
public class FacadeBean  implements FacadeBeanLocal, FacadeBeanRemote {
	
	@EJB(beanName = "JBossMTBeanName")
	JBossMTBeanRemote jBossMTBeanRemote;
	
	@EJB(beanName = "JBossMTBeanName")
	JBossMTBeanLocal jBossMTBeanLocal;
	
	public void testRemoteLookup() {
		try {
			JBossMTBeanRemote lookupedRemote = lookupEJBObject(JBossMTBeanRemote.class,"JBossMTBeanMappedName");
			lookupedRemote.helloRemote();
		} catch (NamingException e) {
			e.printStackTrace();
		}
	}
	
	
	
	public void testEJB2LocalLookup() {
		try {
			JBossMTBeanEJB2LocalHome lookupedLocalHome = lookupEJBObject(JBossMTBeanEJB2LocalHome.class,"thunder.jbossmt.ejb.JBossMTBeanEJB2LocalHome");
			JBossMTBeanEJB2Local lookupedEJB2Local = lookupedLocalHome.create();
			lookupedEJB2Local.helloEJB2Local();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	public void testEJB3LocalInjection(){
		jBossMTBeanLocal.helloLocal();
	}
	public void testEJB3RemoteInjection(){
		jBossMTBeanRemote.helloRemote();
	}
	
	public void testTransactionTimeout() {
		jBossMTBeanRemote.testTransactionTimeoutAttr();
	}
	
	private <T> T lookupEJBObject(Class<T>InterfaceClass, String jndiName) throws NamingException  {

		Hashtable jndiEvn = new Hashtable();
		jndiEvn.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
		jndiEvn.put(Context.URL_PKG_PREFIXES, "org.jboss.naming:org.jnp.interfaces");
		jndiEvn.put(Context.PROVIDER_URL, "jnp://localhost:1099"); // remote machine IP
		InitialContext ctx = new InitialContext(jndiEvn);
		T EJBObject = null;
		EJBObject = (T)ctx.lookup(jndiName);
		return EJBObject;
	}
	
}
